"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));

var _embarkI18n = require("embark-i18n");

var _embarkUtils = require("embark-utils");

class Storage {
  constructor(embark, options) {
    var _context, _context2, _context4;

    this.embark = embark;
    this.embarkConfig = embark.config.embarkConfig;
    this.events = this.embark.events;
    this.storageConfig = embark.config.storageConfig;
    this.plugins = options.plugins;
    embark.registerActionForEvent("pipeline:generateAll:before", (0, _bind.default)(_context = this.addArtifactFile).call(_context, this));
    this.storageNodes = {};
    this.events.setCommandHandler("storage:node:register", (clientName, startCb) => {
      this.storageNodes[clientName] = startCb;
    });
    this.events.setCommandHandler("storage:node:start", (storageConfig, cb) => {
      if (!storageConfig.enabled) {
        return cb();
      }

      const clientName = storageConfig.upload.provider;
      const client = this.storageNodes[clientName];
      if (!client) return cb("storage " + clientName + " not found");

      let onStart = () => {
        this.events.emit("storage:started", clientName);
        cb();
      };

      client.apply(client, [onStart]);
    });
    this.uploadNodes = {};
    this.events.setCommandHandler("storage:upload:register", (clientName, uploadCb) => {
      this.uploadNodes[clientName] = uploadCb;
    });
    this.events.setCommandHandler("storage:upload", (clientName, cb) => {
      const client = this.uploadNodes[clientName];
      if (!client) return cb("upload client for  " + clientName + " not found");
      client.apply(client, [cb]);
    });

    if (this.storageConfig.enabled && (0, _includes.default)(_context2 = this.storageConfig.available_providers).call(_context2, "ipfs")) {
      var _context3;

      (0, _embarkUtils.warnIfPackageNotDefinedLocally)("embark-ipfs", (0, _bind.default)(_context3 = this.embark.logger.warn).call(_context3, this.embark.logger), this.embark.config.embarkConfig);
    }

    if (this.storageConfig.enabled && (0, _includes.default)(_context4 = this.storageConfig.available_providers).call(_context4, "swarm")) {
      var _context5;

      (0, _embarkUtils.warnIfPackageNotDefinedLocally)("embark-swarm", (0, _bind.default)(_context5 = this.embark.logger.warn).call(_context5, this.embark.logger), this.embark.config.embarkConfig);
    }
  }

  addArtifactFile(_params, cb) {
    let config = {
      dappConnection: this.storageConfig.dappConnection
    };
    this.events.request("pipeline:register", {
      path: [this.embarkConfig.generationDir, 'config'],
      file: 'storage.json',
      format: 'json',
      content: config
    }, cb);
  }

}

module.exports = Storage;
//# sourceMappingURL=index.js.map